// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Bot.Connector
{
    
    using System.Collections;
    using System.Collections.Generic;
    using System.Threading;
    using System.Threading.Tasks;

    /// <summary>
    /// Extension methods for Conversations.
    /// </summary>
    public static partial class ConversationsExtensions
    {
            /// <summary>
            /// GetConversations
            /// </summary>
            /// <remarks>
            /// List the Conversations in which this bot has participated.
            ///
            /// GET from this method with a skip token
            ///
            /// The return value is a ConversationsResult, which contains an array of
            /// ConversationMembers and a skip token.  If the skip token is not empty, then
            /// there are further values to be returned. Call this method again with the
            /// returned token to get more values.
            ///
            /// Each ConversationMembers object contains the ID of the conversation and an
            /// array of ChannelAccounts that describe the members of the conversation.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='continuationToken'>
            /// skip or continuation token
            /// </param>
            public static ConversationsResult GetConversations(this IConversations operations, string continuationToken = default(string))
            {
                return operations.GetConversationsAsync(continuationToken).GetAwaiter().GetResult();
            }

            /// <summary>
            /// GetConversations
            /// </summary>
            /// <remarks>
            /// List the Conversations in which this bot has participated.
            ///
            /// GET from this method with a skip token
            ///
            /// The return value is a ConversationsResult, which contains an array of
            /// ConversationMembers and a skip token.  If the skip token is not empty, then
            /// there are further values to be returned. Call this method again with the
            /// returned token to get more values.
            ///
            /// Each ConversationMembers object contains the ID of the conversation and an
            /// array of ChannelAccounts that describe the members of the conversation.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='continuationToken'>
            /// skip or continuation token
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<ConversationsResult> GetConversationsAsync(this IConversations operations, string continuationToken = default(string), CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetConversationsWithHttpMessagesAsync(continuationToken, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// CreateConversation
            /// </summary>
            /// <remarks>
            /// Create a new Conversation.
            ///
            /// POST to this method with a
            /// * Bot being the bot creating the conversation
            /// * IsGroup set to true if this is not a direct message (default is false)
            /// * Members array contining the members you want to have be in the
            /// conversation.
            ///
            /// The return value is a ResourceResponse which contains a conversation id
            /// which is suitable for use
            /// in the message payload and REST API uris.
            ///
            /// Most channels only support the semantics of bots initiating a direct
            /// message conversation.  An example of how to do that would be:
            ///
            /// ```
            /// var resource = await connector.conversations.CreateConversation(new
            /// ConversationParameters(){ Bot = bot, members = new ChannelAccount[] { new
            /// ChannelAccount("user1") } );
            /// await connect.Conversations.SendToConversationAsync(resource.Id, new
            /// Activity() ... ) ;
            ///
            /// ```
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='parameters'>
            /// Parameters to create the conversation from
            /// </param>
            public static ConversationResourceResponse CreateConversation(this IConversations operations, ConversationParameters parameters)
            {
                return operations.CreateConversationAsync(parameters).GetAwaiter().GetResult();
            }

            /// <summary>
            /// CreateConversation
            /// </summary>
            /// <remarks>
            /// Create a new Conversation.
            ///
            /// POST to this method with a
            /// * Bot being the bot creating the conversation
            /// * IsGroup set to true if this is not a direct message (default is false)
            /// * Members array contining the members you want to have be in the
            /// conversation.
            ///
            /// The return value is a ResourceResponse which contains a conversation id
            /// which is suitable for use
            /// in the message payload and REST API uris.
            ///
            /// Most channels only support the semantics of bots initiating a direct
            /// message conversation.  An example of how to do that would be:
            ///
            /// ```
            /// var resource = await connector.conversations.CreateConversation(new
            /// ConversationParameters(){ Bot = bot, members = new ChannelAccount[] { new
            /// ChannelAccount("user1") } );
            /// await connect.Conversations.SendToConversationAsync(resource.Id, new
            /// Activity() ... ) ;
            ///
            /// ```
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='parameters'>
            /// Parameters to create the conversation from
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<ConversationResourceResponse> CreateConversationAsync(this IConversations operations, ConversationParameters parameters, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.CreateConversationWithHttpMessagesAsync(parameters, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// SendToConversation
            /// </summary>
            /// <remarks>
            /// This method allows you to send an activity to the end of a conversation.
            ///
            /// This is slightly different from ReplyToActivity().
            /// * SendToConverstion(conversationId) - will append the activity to the end
            /// of the conversation according to the timestamp or semantics of the channel.
            /// * ReplyToActivity(conversationId,ActivityId) - adds the activity as a reply
            /// to another activity, if the channel supports it. If the channel does not
            /// support nested replies, ReplyToActivity falls back to SendToConversation.
            ///
            /// Use ReplyToActivity when replying to a specific activity in the
            /// conversation.
            ///
            /// Use SendToConversation in all other cases.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='conversationId'>
            /// Conversation ID
            /// </param>
            /// <param name='activity'>
            /// Activity to send
            /// </param>
            public static ResourceResponse SendToConversation(this IConversations operations, string conversationId, Activity activity)
            {
                return operations.SendToConversationAsync(conversationId, activity).GetAwaiter().GetResult();
            }

            /// <summary>
            /// SendToConversation
            /// </summary>
            /// <remarks>
            /// This method allows you to send an activity to the end of a conversation.
            ///
            /// This is slightly different from ReplyToActivity().
            /// * SendToConverstion(conversationId) - will append the activity to the end
            /// of the conversation according to the timestamp or semantics of the channel.
            /// * ReplyToActivity(conversationId,ActivityId) - adds the activity as a reply
            /// to another activity, if the channel supports it. If the channel does not
            /// support nested replies, ReplyToActivity falls back to SendToConversation.
            ///
            /// Use ReplyToActivity when replying to a specific activity in the
            /// conversation.
            ///
            /// Use SendToConversation in all other cases.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='conversationId'>
            /// Conversation ID
            /// </param>
            /// <param name='activity'>
            /// Activity to send
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<ResourceResponse> SendToConversationAsync(this IConversations operations, string conversationId, Activity activity, CancellationToken cancellationToken = default(CancellationToken))
            {
                if (activity.Type == ActivityTypes.Trace && activity.ChannelId != "emulator")
                {
                    return new ResourceResponse(activity.Id ?? string.Empty);
                }

                using (var _result = await operations.SendToConversationWithHttpMessagesAsync(conversationId, activity, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// UpdateActivity
            /// </summary>
            /// <remarks>
            /// Edit an existing activity.
            ///
            /// Some channels allow you to edit an existing activity to reflect the new
            /// state of a bot conversation.
            ///
            /// For example, you can remove buttons after someone has clicked "Approve"
            /// button.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='conversationId'>
            /// Conversation ID
            /// </param>
            /// <param name='activityId'>
            /// activityId to update
            /// </param>
            /// <param name='activity'>
            /// replacement Activity
            /// </param>
            public static ResourceResponse UpdateActivity(this IConversations operations, string conversationId, string activityId, Activity activity)
            {
                return operations.UpdateActivityAsync(conversationId, activityId, activity).GetAwaiter().GetResult();
            }

            /// <summary>
            /// UpdateActivity
            /// </summary>
            /// <remarks>
            /// Edit an existing activity.
            ///
            /// Some channels allow you to edit an existing activity to reflect the new
            /// state of a bot conversation.
            ///
            /// For example, you can remove buttons after someone has clicked "Approve"
            /// button.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='conversationId'>
            /// Conversation ID
            /// </param>
            /// <param name='activityId'>
            /// activityId to update
            /// </param>
            /// <param name='activity'>
            /// replacement Activity
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<ResourceResponse> UpdateActivityAsync(this IConversations operations, string conversationId, string activityId, Activity activity, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.UpdateActivityWithHttpMessagesAsync(conversationId, activityId, activity, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// ReplyToActivity
            /// </summary>
            /// <remarks>
            /// This method allows you to reply to an activity.
            ///
            /// This is slightly different from SendToConversation().
            /// * SendToConverstion(conversationId) - will append the activity to the end
            /// of the conversation according to the timestamp or semantics of the channel.
            /// * ReplyToActivity(conversationId,ActivityId) - adds the activity as a reply
            /// to another activity, if the channel supports it. If the channel does not
            /// support nested replies, ReplyToActivity falls back to SendToConversation.
            ///
            /// Use ReplyToActivity when replying to a specific activity in the
            /// conversation.
            ///
            /// Use SendToConversation in all other cases.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='conversationId'>
            /// Conversation ID
            /// </param>
            /// <param name='activityId'>
            /// activityId the reply is to (OPTIONAL)
            /// </param>
            /// <param name='activity'>
            /// Activity to send
            /// </param>
            public static ResourceResponse ReplyToActivity(this IConversations operations, string conversationId, string activityId, Activity activity)
            {
                return operations.ReplyToActivityAsync(conversationId, activityId, activity).GetAwaiter().GetResult();
            }

            /// <summary>
            /// ReplyToActivity
            /// </summary>
            /// <remarks>
            /// This method allows you to reply to an activity.
            ///
            /// This is slightly different from SendToConversation().
            /// * SendToConverstion(conversationId) - will append the activity to the end
            /// of the conversation according to the timestamp or semantics of the channel.
            /// * ReplyToActivity(conversationId,ActivityId) - adds the activity as a reply
            /// to another activity, if the channel supports it. If the channel does not
            /// support nested replies, ReplyToActivity falls back to SendToConversation.
            ///
            /// Use ReplyToActivity when replying to a specific activity in the
            /// conversation.
            ///
            /// Use SendToConversation in all other cases.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='conversationId'>
            /// Conversation ID
            /// </param>
            /// <param name='activityId'>
            /// activityId the reply is to (OPTIONAL)
            /// </param>
            /// <param name='activity'>
            /// Activity to send
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<ResourceResponse> ReplyToActivityAsync(this IConversations operations, string conversationId, string activityId, Activity activity, CancellationToken cancellationToken = default(CancellationToken))
            {
                if (activity.Type == ActivityTypes.Trace && activity.ChannelId != "emulator")
                {
                    return new ResourceResponse(activity.Id ?? string.Empty);
                }

                using (var _result = await operations.ReplyToActivityWithHttpMessagesAsync(conversationId, activityId, activity, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// DeleteActivity
            /// </summary>
            /// <remarks>
            /// Delete an existing activity.
            ///
            /// Some channels allow you to delete an existing activity, and if successful
            /// this method will remove the specified activity.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='conversationId'>
            /// Conversation ID
            /// </param>
            /// <param name='activityId'>
            /// activityId to delete
            /// </param>
            public static void DeleteActivity(this IConversations operations, string conversationId, string activityId)
            {
                operations.DeleteActivityAsync(conversationId, activityId).GetAwaiter().GetResult();
            }

            /// <summary>
            /// DeleteActivity
            /// </summary>
            /// <remarks>
            /// Delete an existing activity.
            ///
            /// Some channels allow you to delete an existing activity, and if successful
            /// this method will remove the specified activity.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='conversationId'>
            /// Conversation ID
            /// </param>
            /// <param name='activityId'>
            /// activityId to delete
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task DeleteActivityAsync(this IConversations operations, string conversationId, string activityId, CancellationToken cancellationToken = default(CancellationToken))
            {
                (await operations.DeleteActivityWithHttpMessagesAsync(conversationId, activityId, null, cancellationToken).ConfigureAwait(false)).Dispose();
            }

            /// <summary>
            /// GetConversationMembers
            /// </summary>
            /// <remarks>
            /// Enumerate the members of a converstion.
            ///
            /// This REST API takes a ConversationId and returns an array of ChannelAccount
            /// objects representing the members of the conversation.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='conversationId'>
            /// Conversation ID
            /// </param>
            public static IList<ChannelAccount> GetConversationMembers(this IConversations operations, string conversationId)
            {
                return operations.GetConversationMembersAsync(conversationId).GetAwaiter().GetResult();
            }

            /// <summary>
            /// GetConversationMembers
            /// </summary>
            /// <remarks>
            /// Enumerate the members of a converstion.
            ///
            /// This REST API takes a ConversationId and returns an array of ChannelAccount
            /// objects representing the members of the conversation.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='conversationId'>
            /// Conversation ID
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IList<ChannelAccount>> GetConversationMembersAsync(this IConversations operations, string conversationId, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetConversationMembersWithHttpMessagesAsync(conversationId, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// DeleteConversationMember
            /// </summary>
            /// <remarks>
            /// Deletes a member from a converstion.
            ///
            /// This REST API takes a ConversationId and a memberId (of type string) and
            /// removes that member from the conversation. If that member was the last
            /// member
            /// of the conversation, the conversation will also be deleted.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='conversationId'>
            /// Conversation ID
            /// </param>
            /// <param name='memberId'>
            /// ID of the member to delete from this conversation
            /// </param>
            public static void DeleteConversationMember(this IConversations operations, string conversationId, string memberId)
            {
                operations.DeleteConversationMemberAsync(conversationId, memberId).GetAwaiter().GetResult();
            }

            /// <summary>
            /// DeleteConversationMember
            /// </summary>
            /// <remarks>
            /// Deletes a member from a converstion.
            ///
            /// This REST API takes a ConversationId and a memberId (of type string) and
            /// removes that member from the conversation. If that member was the last
            /// member
            /// of the conversation, the conversation will also be deleted.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='conversationId'>
            /// Conversation ID
            /// </param>
            /// <param name='memberId'>
            /// ID of the member to delete from this conversation
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task DeleteConversationMemberAsync(this IConversations operations, string conversationId, string memberId, CancellationToken cancellationToken = default(CancellationToken))
            {
                (await operations.DeleteConversationMemberWithHttpMessagesAsync(conversationId, memberId, null, cancellationToken).ConfigureAwait(false)).Dispose();
            }

            /// <summary>
            /// GetActivityMembers
            /// </summary>
            /// <remarks>
            /// Enumerate the members of an activity.
            ///
            /// This REST API takes a ConversationId and a ActivityId, returning an array
            /// of ChannelAccount objects representing the members of the particular
            /// activity in the conversation.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='conversationId'>
            /// Conversation ID
            /// </param>
            /// <param name='activityId'>
            /// Activity ID
            /// </param>
            public static IList<ChannelAccount> GetActivityMembers(this IConversations operations, string conversationId, string activityId)
            {
                return operations.GetActivityMembersAsync(conversationId, activityId).GetAwaiter().GetResult();
            }

            /// <summary>
            /// GetActivityMembers
            /// </summary>
            /// <remarks>
            /// Enumerate the members of an activity.
            ///
            /// This REST API takes a ConversationId and a ActivityId, returning an array
            /// of ChannelAccount objects representing the members of the particular
            /// activity in the conversation.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='conversationId'>
            /// Conversation ID
            /// </param>
            /// <param name='activityId'>
            /// Activity ID
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<IList<ChannelAccount>> GetActivityMembersAsync(this IConversations operations, string conversationId, string activityId, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.GetActivityMembersWithHttpMessagesAsync(conversationId, activityId, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

            /// <summary>
            /// UploadAttachment
            /// </summary>
            /// <remarks>
            /// Upload an attachment directly into a channel's blob storage.
            ///
            /// This is useful because it allows you to store data in a compliant store
            /// when dealing with enterprises.
            ///
            /// The response is a ResourceResponse which contains an AttachmentId which is
            /// suitable for using with the attachments API.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='conversationId'>
            /// Conversation ID
            /// </param>
            /// <param name='attachmentUpload'>
            /// Attachment data
            /// </param>
            public static ResourceResponse UploadAttachment(this IConversations operations, string conversationId, AttachmentData attachmentUpload)
            {
                return operations.UploadAttachmentAsync(conversationId, attachmentUpload).GetAwaiter().GetResult();
            }

            /// <summary>
            /// UploadAttachment
            /// </summary>
            /// <remarks>
            /// Upload an attachment directly into a channel's blob storage.
            ///
            /// This is useful because it allows you to store data in a compliant store
            /// when dealing with enterprises.
            ///
            /// The response is a ResourceResponse which contains an AttachmentId which is
            /// suitable for using with the attachments API.
            /// </remarks>
            /// <param name='operations'>
            /// The operations group for this extension method.
            /// </param>
            /// <param name='conversationId'>
            /// Conversation ID
            /// </param>
            /// <param name='attachmentUpload'>
            /// Attachment data
            /// </param>
            /// <param name='cancellationToken'>
            /// The cancellation token.
            /// </param>
            public static async Task<ResourceResponse> UploadAttachmentAsync(this IConversations operations, string conversationId, AttachmentData attachmentUpload, CancellationToken cancellationToken = default(CancellationToken))
            {
                using (var _result = await operations.UploadAttachmentWithHttpMessagesAsync(conversationId, attachmentUpload, null, cancellationToken).ConfigureAwait(false))
                {
                    return _result.Body;
                }
            }

    }
}
