// <auto-generated>
// Code generated by Microsoft (R) AutoRest Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.
// </auto-generated>

namespace Microsoft.Bot.Connector
{
    using Newtonsoft.Json;
    using System.Linq;

    /// <summary>
    /// A PaymentResponse is returned when a user has selected a payment method
    /// and approved a payment request
    /// </summary>
    public partial class PaymentResponse
    {
        /// <summary>
        /// Initializes a new instance of the PaymentResponse class.
        /// </summary>
        public PaymentResponse()
        {
            CustomInit();
        }

        /// <summary>
        /// Initializes a new instance of the PaymentResponse class.
        /// </summary>
        /// <param name="methodName">The payment method identifier for the
        /// payment method that the user selected to fulfil the
        /// transaction</param>
        /// <param name="details">A JSON-serializable object that provides a
        /// payment method specific message used by the merchant to process the
        /// transaction and determine successful fund transfer</param>
        /// <param name="shippingAddress">If the requestShipping flag was set
        /// to true in the PaymentOptions passed to the PaymentRequest
        /// constructor, then shippingAddress will be the full and final
        /// shipping address chosen by the user</param>
        /// <param name="shippingOption">If the requestShipping flag was set to
        /// true in the PaymentOptions passed to the PaymentRequest
        /// constructor, then shippingOption will be the id attribute of the
        /// selected shipping option</param>
        /// <param name="payerEmail">If the requestPayerEmail flag was set to
        /// true in the PaymentOptions passed to the PaymentRequest
        /// constructor, then payerEmail will be the email address chosen by
        /// the user</param>
        /// <param name="payerPhone">If the requestPayerPhone flag was set to
        /// true in the PaymentOptions passed to the PaymentRequest
        /// constructor, then payerPhone will be the phone number chosen by the
        /// user</param>
        public PaymentResponse(string methodName = default(string), object details = default(object), PaymentAddress shippingAddress = default(PaymentAddress), string shippingOption = default(string), string payerEmail = default(string), string payerPhone = default(string))
        {
            MethodName = methodName;
            Details = details;
            ShippingAddress = shippingAddress;
            ShippingOption = shippingOption;
            PayerEmail = payerEmail;
            PayerPhone = payerPhone;
            CustomInit();
        }

        /// <summary>
        /// An initialization method that performs custom operations like setting defaults
        /// </summary>
        partial void CustomInit();

        /// <summary>
        /// Gets or sets the payment method identifier for the payment method
        /// that the user selected to fulfil the transaction
        /// </summary>
        [JsonProperty(PropertyName = "methodName")]
        public string MethodName { get; set; }

        /// <summary>
        /// Gets or sets a JSON-serializable object that provides a payment
        /// method specific message used by the merchant to process the
        /// transaction and determine successful fund transfer
        /// </summary>
        [JsonProperty(PropertyName = "details")]
        public object Details { get; set; }

        /// <summary>
        /// Gets or sets if the requestShipping flag was set to true in the
        /// PaymentOptions passed to the PaymentRequest constructor, then
        /// shippingAddress will be the full and final shipping address chosen
        /// by the user
        /// </summary>
        [JsonProperty(PropertyName = "shippingAddress")]
        public PaymentAddress ShippingAddress { get; set; }

        /// <summary>
        /// Gets or sets if the requestShipping flag was set to true in the
        /// PaymentOptions passed to the PaymentRequest constructor, then
        /// shippingOption will be the id attribute of the selected shipping
        /// option
        /// </summary>
        [JsonProperty(PropertyName = "shippingOption")]
        public string ShippingOption { get; set; }

        /// <summary>
        /// Gets or sets if the requestPayerEmail flag was set to true in the
        /// PaymentOptions passed to the PaymentRequest constructor, then
        /// payerEmail will be the email address chosen by the user
        /// </summary>
        [JsonProperty(PropertyName = "payerEmail")]
        public string PayerEmail { get; set; }

        /// <summary>
        /// Gets or sets if the requestPayerPhone flag was set to true in the
        /// PaymentOptions passed to the PaymentRequest constructor, then
        /// payerPhone will be the phone number chosen by the user
        /// </summary>
        [JsonProperty(PropertyName = "payerPhone")]
        public string PayerPhone { get; set; }

    }
}
